import 'package:dotup_flutter_widgets/src/layout/device/device.dart';
import 'package:flutter/foundation.dart';

class DeviceValue<T> {
  const DeviceValue({
    T? web,
    T? phone,
    T? tablet,
    T? desktop,
    T? fallback,
  })  : _web = web,
        _tablet = tablet,
        _phone = phone,
        _desktop = desktop,
        _fallback = fallback;

  final T? _fallback;
  T get fallback => _fallback!;

  final T? _web;
  T get web => _web ?? _fallback!;

  final T? _tablet;
  T get tablet => _tablet ?? _fallback!;

  final T? _phone;
  T get phone => _phone ?? _fallback!;

  final T? _desktop;
  T get desktop => _desktop ?? _fallback!;

  T get value => _getValue();

  T _getValue() {
    switch (Device.type) {
      case DeviceType.phone:
        return phone;
      case DeviceType.tablet:
        return tablet;
      case DeviceType.desktop:
        return desktop;
      case DeviceType.web:
        return web;
      default:
        return fallback;
    }
  }
}
